<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: SmartLED.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SmartLED.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * SmartLED.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Oct 22, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_SMARTLED_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_SMARTLED_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="structpixel__t.html">   14</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="structpixel__t.html#a912496dc782ecc3cea2f89eb79b7c9a0">   18</a></span>&#160;    uint8_t <a class="code" href="structpixel__t.html#a912496dc782ecc3cea2f89eb79b7c9a0">red</a>;</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="structpixel__t.html#a945c55299b107661d118e849b388039b">   22</a></span>&#160;    uint8_t <a class="code" href="structpixel__t.html#a945c55299b107661d118e849b388039b">green</a>;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="structpixel__t.html#a32f72c7c5c7c932c7e554d05f7390941">   26</a></span>&#160;    uint8_t <a class="code" href="structpixel__t.html#a32f72c7c5c7c932c7e554d05f7390941">blue</a>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;} <a class="code" href="structpixel__t.html">pixel_t</a>;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="classSmartLED.html">   30</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSmartLED.html">SmartLED</a> {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <a class="code" href="classSmartLED.html">SmartLED</a>();</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classSmartLED.html">SmartLED</a>();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    uint32_t <a class="code" href="classSmartLED.html#a735d83c9c1f664ea3328daeb36748eb6">getBrightness</a>();</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    uint16_t <a class="code" href="classSmartLED.html#a1c560b3cc7f1dc88337d22cbd890f933">getPixelCount</a>();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> init() = 0;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> show() = 0;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSmartLED.html#afd7bcb3a6606ee885978c94cc5bd3833">setBrightness</a>(uint32_t percent);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSmartLED.html#a1d7155c63ed77ae070575dcbc960292e">setColorOrder</a>(<span class="keywordtype">char</span>* order);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSmartLED.html#aa0e7fcf8f943748d68c23dbef90b52a6">setPixel</a>(uint16_t index, uint8_t red, uint8_t green, uint8_t blue);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSmartLED.html#aa0e7fcf8f943748d68c23dbef90b52a6">setPixel</a>(uint16_t index, <a class="code" href="structpixel__t.html">pixel_t</a> pixel);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSmartLED.html#aa0e7fcf8f943748d68c23dbef90b52a6">setPixel</a>(uint16_t index, uint32_t pixel);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordtype">void</span> setPixelCount(uint16_t pixelCount);</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSmartLED.html#a0d25c9253f280f79c3fee565d0bd3efd">setHSBPixel</a>(uint16_t index, uint16_t hue, uint8_t saturation, uint8_t brightness);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSmartLED.html#a38c11b8195f7d149053850a554c6a85e">clear</a>();</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    uint32_t       m_brightness;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">char</span>*          m_colorOrder;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    uint16_t       m_pixelCount;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <a class="code" href="structpixel__t.html">pixel_t</a>*       m_pixels;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;};</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_SMARTLED_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classSmartLED_html_a735d83c9c1f664ea3328daeb36748eb6"><div class="ttname"><a href="classSmartLED.html#a735d83c9c1f664ea3328daeb36748eb6">SmartLED::getBrightness</a></div><div class="ttdeci">uint32_t getBrightness()</div><div class="ttdoc">Get the brightness as a percentage.</div><div class="ttdef"><b>Definition:</b> SmartLED.cpp:47</div></div>
<div class="ttc" id="classSmartLED_html_a0d25c9253f280f79c3fee565d0bd3efd"><div class="ttname"><a href="classSmartLED.html#a0d25c9253f280f79c3fee565d0bd3efd">SmartLED::setHSBPixel</a></div><div class="ttdeci">void setHSBPixel(uint16_t index, uint16_t hue, uint8_t saturation, uint8_t brightness)</div><div class="ttdoc">Set the given pixel to the specified HSB color.</div><div class="ttdef"><b>Definition:</b> SmartLED.cpp:158</div></div>
<div class="ttc" id="structpixel__t_html"><div class="ttname"><a href="structpixel__t.html">pixel_t</a></div><div class="ttdoc">A data type representing the color of a pixel.</div><div class="ttdef"><b>Definition:</b> SmartLED.h:14</div></div>
<div class="ttc" id="classSmartLED_html_a1d7155c63ed77ae070575dcbc960292e"><div class="ttname"><a href="classSmartLED.html#a1d7155c63ed77ae070575dcbc960292e">SmartLED::setColorOrder</a></div><div class="ttdeci">void setColorOrder(char *order)</div><div class="ttdoc">Set the color order of data sent to the LEDs.</div><div class="ttdef"><b>Definition:</b> SmartLED.cpp:82</div></div>
<div class="ttc" id="structpixel__t_html_a912496dc782ecc3cea2f89eb79b7c9a0"><div class="ttname"><a href="structpixel__t.html#a912496dc782ecc3cea2f89eb79b7c9a0">pixel_t::red</a></div><div class="ttdeci">uint8_t red</div><div class="ttdoc">The red component of the pixel.</div><div class="ttdef"><b>Definition:</b> SmartLED.h:18</div></div>
<div class="ttc" id="classSmartLED_html_a1c560b3cc7f1dc88337d22cbd890f933"><div class="ttname"><a href="classSmartLED.html#a1c560b3cc7f1dc88337d22cbd890f933">SmartLED::getPixelCount</a></div><div class="ttdeci">uint16_t getPixelCount()</div><div class="ttdoc">Return the number of pixels in the chain.</div><div class="ttdef"><b>Definition:</b> SmartLED.cpp:56</div></div>
<div class="ttc" id="structpixel__t_html_a32f72c7c5c7c932c7e554d05f7390941"><div class="ttname"><a href="structpixel__t.html#a32f72c7c5c7c932c7e554d05f7390941">pixel_t::blue</a></div><div class="ttdeci">uint8_t blue</div><div class="ttdoc">The blue component of the pixel.</div><div class="ttdef"><b>Definition:</b> SmartLED.h:26</div></div>
<div class="ttc" id="classSmartLED_html_a38c11b8195f7d149053850a554c6a85e"><div class="ttname"><a href="classSmartLED.html#a38c11b8195f7d149053850a554c6a85e">SmartLED::clear</a></div><div class="ttdeci">void clear()</div><div class="ttdoc">Clear all the pixel colors.</div><div class="ttdef"><b>Definition:</b> SmartLED.cpp:34</div></div>
<div class="ttc" id="classSmartLED_html_aa0e7fcf8f943748d68c23dbef90b52a6"><div class="ttname"><a href="classSmartLED.html#aa0e7fcf8f943748d68c23dbef90b52a6">SmartLED::setPixel</a></div><div class="ttdeci">void setPixel(uint16_t index, uint8_t red, uint8_t green, uint8_t blue)</div><div class="ttdoc">Set the given pixel to the specified color.</div><div class="ttdef"><b>Definition:</b> SmartLED.cpp:99</div></div>
<div class="ttc" id="classSmartLED_html_afd7bcb3a6606ee885978c94cc5bd3833"><div class="ttname"><a href="classSmartLED.html#afd7bcb3a6606ee885978c94cc5bd3833">SmartLED::setBrightness</a></div><div class="ttdeci">void setBrightness(uint32_t percent)</div><div class="ttdoc">Set the brightness as a percentage.</div><div class="ttdef"><b>Definition:</b> SmartLED.cpp:65</div></div>
<div class="ttc" id="classSmartLED_html"><div class="ttname"><a href="classSmartLED.html">SmartLED</a></div><div class="ttdef"><b>Definition:</b> SmartLED.h:30</div></div>
<div class="ttc" id="structpixel__t_html_a945c55299b107661d118e849b388039b"><div class="ttname"><a href="structpixel__t.html#a945c55299b107661d118e849b388039b">pixel_t::green</a></div><div class="ttdeci">uint8_t green</div><div class="ttdoc">The green component of the pixel.</div><div class="ttdef"><b>Definition:</b> SmartLED.h:22</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
